Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 1ffa216657b5beb85210757a5d292a8b64bd5b79)
+++ src/molecules.cpp	(revision 69eb71ca95b6ddd8113c4c58130d3a649792ac26)
@@ -2102,7 +2153,7 @@
     BackEdge = BackEdgeStack->PopFirst();
     // this is the target
-    Root = BackEdge->leftatom;  
+    Root = BackEdge->leftatom;
     // this is the source point
-    Walker = BackEdge->rightatom; 
+    Walker = BackEdge->rightatom;
     ShortestPathList[Walker->nr] = 0;
     BFSStack->ClearStack();  // start with empty BFS stack
@@ -2118,5 +2169,5 @@
         if (Binder != BackEdge) { // only walk along DFS spanning tree (otherwise we always find SP of one being backedge Binder)
           OtherAtom = Binder->GetOtherAtom(Walker);
-#ifdef ADDHYDROGEN          
+#ifdef ADDHYDROGEN
           if (OtherAtom->type->Z != 1) {
 #endif
@@ -2127,5 +2178,5 @@
               PredecessorList[OtherAtom->nr] = Walker;  // Walker is the predecessor
               ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
-              *out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl; 
+              *out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
               //if (ShortestPathList[OtherAtom->nr] < MinimumRingSize[Walker->GetTrueFather()->nr]) { // Check for maximum distance
                 *out << Verbose(3) << "Putting OtherAtom into queue." << endl;
@@ -2137,5 +2188,5 @@
             if (OtherAtom == Root)
               break;
-#ifdef ADDHYDROGEN          
+#ifdef ADDHYDROGEN
           } else {
             *out << Verbose(2) << "Skipping hydrogen atom " << *OtherAtom << "." << endl;
@@ -2175,5 +2226,5 @@
       }
     } while ((!BFSStack->IsEmpty()) && (OtherAtom != Root) && (OtherAtom != NULL)); // || (ShortestPathList[OtherAtom->nr] < MinimumRingSize[Walker->GetTrueFather()->nr])));
-    
+
     if (OtherAtom == Root) {
       // now climb back the predecessor list and thus find the cycle members
@@ -2203,5 +2254,5 @@
       *out << Verbose(1) << "No ring containing " << *Root << " with length equal to or smaller than " << MinimumRingSize[Walker->GetTrueFather()->nr] << " found." << endl;
     }
-    
+
     // now clean the lists
     while (!TouchedStack->IsEmpty()){
@@ -2213,9 +2264,9 @@
   }
   if (MinRingSize != -1) {
-    // go over all atoms 
+    // go over all atoms
     Root = start;
     while(Root->next != end) {
       Root = Root->next;
-      
+
       if (MinimumRingSize[Root->GetTrueFather()->nr] == AtomCount) { // check whether MinimumRingSize is set, if not BFS to next where it is
         Walker = Root;
@@ -2254,7 +2305,7 @@
           }
           ColorList[Walker->nr] = black;
-          //*out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl; 
+          //*out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
         }
-    
+
         // now clean the lists
         while (!TouchedStack->IsEmpty()){
@@ -2305,5 +2356,5 @@
 void molecule::OutputComponentNumber(ofstream *out, atom *vertex)
 {
-  for(int i=0;i<NumberOfBondsPerAtom[vertex->nr];i++) 
+  for(int i=0;i<NumberOfBondsPerAtom[vertex->nr];i++)
     *out << vertex->ComponentNr[i] << "  ";
 };
@@ -2383,5 +2434,5 @@
 {
   int c = 0;
-  int FragmentCount; 
+  int FragmentCount;
   // get maximum bond degree
   atom *Walker = start;
@@ -2393,10 +2444,10 @@
   *out << Verbose(1) << "Upper limit for this subgraph is " << FragmentCount << " for " << NoNonHydrogen << " non-H atoms with maximum bond degree of " << c << "." << endl;
   return FragmentCount;
-};  
+};
 
 /** Scans a single line for number and puts them into \a KeySet.
  * \param *out output stream for debugging
  * \param *buffer buffer to scan
- * \param &CurrentSet filled KeySet on return 
+ * \param &CurrentSet filled KeySet on return
  * \return true - at least one valid atom id parsed, false - CurrentSet is empty
  */
@@ -2406,5 +2457,5 @@
   int AtomNr;
   int status = 0;
-  
+
   line.str(buffer);
   while (!line.eof()) {
@@ -2442,9 +2493,9 @@
   double TEFactor;
   char *filename = (char *) Malloc(sizeof(char)*MAXSTRINGSIZE, "molecule::ParseKeySetFile - filename");
-  
+
   if (FragmentList == NULL) { // check list pointer
     FragmentList = new Graph;
   }
-  
+
   // 1st pass: open file and read
   *out << Verbose(1) << "Parsing the KeySet file ... " << endl;
@@ -2475,5 +2526,5 @@
     status = false;
   }
-  
+
   // 2nd pass: open TEFactors file and read
   *out << Verbose(1) << "Parsing the TEFactors file ... " << endl;
@@ -2487,5 +2538,5 @@
         InputFile >> TEFactor;
         (*runner).second.second = TEFactor;
-        *out << Verbose(2) << "Setting " << ++NumberOfFragments << " fragment's TEFactor to " << (*runner).second.second << "." << endl; 
+        *out << Verbose(2) << "Setting " << ++NumberOfFragments << " fragment's TEFactor to " << (*runner).second.second << "." << endl;
       } else {
         status = false;
@@ -2528,5 +2579,5 @@
   if(output != NULL) {
     for(Graph::iterator runner = KeySetList.begin(); runner != KeySetList.end(); runner++) {
-      for (KeySet::iterator sprinter = (*runner).first.begin();sprinter != (*runner).first.end(); sprinter++) { 
+      for (KeySet::iterator sprinter = (*runner).first.begin();sprinter != (*runner).first.end(); sprinter++) {
         if (sprinter != (*runner).first.begin())
           output << "\t";
@@ -2594,5 +2645,5 @@
     status = false;
   }
-  
+
   return status;
 };
@@ -2603,5 +2654,5 @@
  * \param **ListOfAtoms allocated (molecule::AtomCount) and filled lookup table for ids (Atom::nr) to *Atom
  * \return true - structure is equal, false - not equivalence
- */ 
+ */
 bool molecule::CheckAdjacencyFileAgainstMolecule(ofstream *out, char *path, atom **ListOfAtoms)
 {
@@ -2610,5 +2661,5 @@
   bool status = true;
   char *buffer = (char *) Malloc(sizeof(char)*MAXSTRINGSIZE, "molecule::CheckAdjacencyFileAgainstMolecule: *buffer");
-  
+
   filename << path << "/" << FRAGMENTPREFIX << ADJACENCYFILE;
   File.open(filename.str().c_str(), ios::out);
@@ -2669,5 +2720,5 @@
   *out << endl;
   Free((void **)&buffer, "molecule::CheckAdjacencyFileAgainstMolecule: *buffer");
-  
+
   return status;
 };
@@ -2691,5 +2742,5 @@
   for(int i=AtomCount;i--;)
     AtomMask[i] = false;
-  
+
   if (Order < 0) { // adaptive increase of BondOrder per site
     if (AtomMask[AtomCount] == true)  // break after one step
@@ -2731,5 +2782,5 @@
           line >> ws >> Value; // skip time entry
           line >> ws >> Value;
-          No -= 1;  // indices start at 1 in file, not 0 
+          No -= 1;  // indices start at 1 in file, not 0
           //*out << Verbose(2) << " - yields (" << No << "," << Value << ", " << FragOrder << ")" << endl;
 
@@ -2740,8 +2791,8 @@
             // as the smallest number in each set has always been the root (we use global id to keep the doubles away), seek smallest and insert into AtomMask
             pair <map<int, pair<double,int> >::iterator, bool> InsertedElement = AdaptiveCriteriaList.insert( make_pair(*((*marker).second.begin()), pair<double,int>( fabs(Value), FragOrder) ));
-            map<int, pair<double,int> >::iterator PresentItem = InsertedElement.first; 
+            map<int, pair<double,int> >::iterator PresentItem = InsertedElement.first;
             if (!InsertedElement.second) { // this root is already present
-              if ((*PresentItem).second.second < FragOrder)  // if order there is lower, update entry with higher-order term 
-                //if ((*PresentItem).second.first < (*runner).first)    // as higher-order terms are not always better, we skip this part (which would always include this site into adaptive increase) 
+              if ((*PresentItem).second.second < FragOrder)  // if order there is lower, update entry with higher-order term
+                //if ((*PresentItem).second.first < (*runner).first)    // as higher-order terms are not always better, we skip this part (which would always include this site into adaptive increase)
                 {  // if value is smaller, update value and order
                 (*PresentItem).second.first = fabs(Value);
@@ -2781,9 +2832,9 @@
         Walker = FindAtom(No);
         //if (Walker->AdaptiveOrder < MinimumRingSize[Walker->nr]) {
-          *out << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", setting entry " << No << " of Atom mask to true." << endl; 
+          *out << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", setting entry " << No << " of Atom mask to true." << endl;
           AtomMask[No] = true;
           status = true;
         //} else
-          //*out << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", however MinimumRingSize of " << MinimumRingSize[Walker->nr] << " does not allow further adaptive increase." << endl; 
+          //*out << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", however MinimumRingSize of " << MinimumRingSize[Walker->nr] << " does not allow further adaptive increase." << endl;
       }
       // close and done
@@ -2819,5 +2870,5 @@
     if ((Order == 0) && (AtomMask[AtomCount] == false))  // single stepping, just check
       status = true;
-      
+
     if (!status) {
       if (Order == 0)
@@ -2827,5 +2878,5 @@
     }
   }
-  
+
   // print atom mask for debugging
   *out << "              ";
@@ -2836,5 +2887,5 @@
     *out << (AtomMask[i] ? "t" : "f");
   *out << endl;
- 
+
   return status;
 };
@@ -2850,5 +2901,5 @@
   int AtomNo = 0;
   atom *Walker = NULL;
-  
+
   if (SortIndex != NULL) {
     *out << Verbose(1) << "SortIndex is " << SortIndex << " and not NULL as expected." << endl;
@@ -2908,6 +2959,6 @@
   atom **ListOfAtoms = NULL;
   atom ***ListOfLocalAtoms = NULL;
-  bool *AtomMask = NULL; 
-  
+  bool *AtomMask = NULL;
+
   *out << endl;
 #ifdef ADDHYDROGEN
@@ -2918,7 +2969,7 @@
 
   // ++++++++++++++++++++++++++++ INITIAL STUFF: Bond structure analysis, file parsing, ... ++++++++++++++++++++++++++++++++++++++++++
-  
+
   // ===== 1. Check whether bond structure is same as stored in files ====
-  
+
   // fill the adjacency list
   CreateListOfBondsPerAtom(out);
@@ -2926,7 +2977,7 @@
   // create lookup table for Atom::nr
   FragmentationToDo = FragmentationToDo && CreateFatherLookupTable(out, start, end, ListOfAtoms, AtomCount);
-  
+
   // === compare it with adjacency file ===
-  FragmentationToDo = FragmentationToDo && CheckAdjacencyFileAgainstMolecule(out, configuration->configpath, ListOfAtoms); 
+  FragmentationToDo = FragmentationToDo && CheckAdjacencyFileAgainstMolecule(out, configuration->configpath, ListOfAtoms);
   Free((void **)&ListOfAtoms, "molecule::FragmentMolecule - **ListOfAtoms");
 
@@ -2957,5 +3008,5 @@
     delete(LocalBackEdgeStack);
   }
-  
+
   // ===== 3. if structure still valid, parse key set file and others =====
   FragmentationToDo = FragmentationToDo && ParseKeySetFile(out, configuration->configpath, ParsedFragmentList);
@@ -2963,7 +3014,7 @@
   // ===== 4. check globally whether there's something to do actually (first adaptivity check)
   FragmentationToDo = FragmentationToDo && ParseOrderAtSiteFromFile(out, configuration->configpath);
-  
-  // =================================== Begin of FRAGMENTATION =============================== 
-  // ===== 6a. assign each keyset to its respective subgraph ===== 
+
+  // =================================== Begin of FRAGMENTATION ===============================
+  // ===== 6a. assign each keyset to its respective subgraph =====
   Subgraphs->next->AssignKeySetsToFragment(out, this, ParsedFragmentList, ListOfLocalAtoms, FragmentList, (FragmentCounter = 0), true);
 
@@ -2976,5 +3027,5 @@
     FragmentationToDo = FragmentationToDo || CheckOrder;
     AtomMask[AtomCount] = true;   // last plus one entry is used as marker that we have been through this loop once already in CheckOrderAtSite()
-    // ===== 6b. fill RootStack for each subgraph (second adaptivity check) ===== 
+    // ===== 6b. fill RootStack for each subgraph (second adaptivity check) =====
     Subgraphs->next->FillRootStackForSubgraphs(out, RootStack, AtomMask, (FragmentCounter = 0));
 
@@ -3000,5 +3051,5 @@
   delete(ParsedFragmentList);
   delete[](MinimumRingSize);
-  
+
 
   // ==================================== End of FRAGMENTATION ============================================
@@ -3006,5 +3057,5 @@
   // ===== 8a. translate list into global numbers (i.e. ones that are valid in "this" molecule, not in MolecularWalker->Leaf)
   Subgraphs->next->TranslateIndicesToGlobalIDs(out, FragmentList, (FragmentCounter = 0), TotalNumberOfKeySets, TotalGraph);
-  
+
   // free subgraph memory again
   FragmentCounter = 0;
@@ -3031,10 +3082,10 @@
     }
     *out << k << "/" << BondFragments->NumberOfMolecules << " fragments generated from the keysets." << endl;
-    
+
     // ===== 9. Save fragments' configuration and keyset files et al to disk ===
     if (BondFragments->NumberOfMolecules != 0) {
       // create the SortIndex from BFS labels to order in the config file
       CreateMappingLabelsToConfigSequence(out, SortIndex);
-      
+
       *out << Verbose(1) << "Writing " << BondFragments->NumberOfMolecules << " possible bond fragmentation configs" << endl;
       if (BondFragments->OutputConfigForListOfFragments(out, configuration, SortIndex))
@@ -3042,30 +3093,30 @@
       else
         *out << Verbose(1) << "Some config writing failed." << endl;
-  
+
       // store force index reference file
       BondFragments->StoreForcesFile(out, configuration->configpath, SortIndex);
-      
-      // store keysets file 
+
+      // store keysets file
       StoreKeySetFile(out, TotalGraph, configuration->configpath);
-  
-      // store Adjacency file 
+
+      // store Adjacency file
       StoreAdjacencyToFile(out, configuration->configpath);
-  
+
       // store Hydrogen saturation correction file
       BondFragments->AddHydrogenCorrection(out, configuration->configpath);
-      
+
       // store adaptive orders into file
       StoreOrderAtSiteFile(out, configuration->configpath);
-      
+
       // restore orbital and Stop values
       CalculateOrbitals(*configuration);
-      
+
       // free memory for bond part
       *out << Verbose(1) << "Freeing bond memory" << endl;
       delete(FragmentList); // remove bond molecule from memory
-      Free((void **)&SortIndex, "molecule::FragmentMolecule: *SortIndex"); 
+      Free((void **)&SortIndex, "molecule::FragmentMolecule: *SortIndex");
     } else
       *out << Verbose(1) << "FragmentList is zero on return, splitting failed." << endl;
-  //} else 
+  //} else
   //  *out << Verbose(1) << "No fragments to store." << endl;
   *out << Verbose(0) << "End of bond fragmentation." << endl;
@@ -3093,8 +3144,8 @@
   atom *Walker = NULL, *OtherAtom = NULL;
   ReferenceStack->Push(Binder);
-  
+
   do {  // go through all bonds and push local ones
     Walker = ListOfLocalAtoms[Binder->leftatom->nr];  // get one atom in the reference molecule
-    if (Walker != NULL) // if this Walker exists in the subgraph ... 
+    if (Walker != NULL) // if this Walker exists in the subgraph ...
     	for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {    // go through the local list of bonds
       	OtherAtom = ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker);
@@ -3109,5 +3160,5 @@
     ReferenceStack->Push(Binder);
   } while (FirstBond != Binder);
-  
+
   return status;
 };
@@ -3185,5 +3236,5 @@
       Walker->AdaptiveOrder = OrderArray[Walker->nr];
       Walker->MaxOrder = MaxArray[Walker->nr];
-      *out << Verbose(2) << *Walker << " gets order " << (int)Walker->AdaptiveOrder << " and is " << (!Walker->MaxOrder ? "not " : " ") << "maxed." << endl; 
+      *out << Verbose(2) << *Walker << " gets order " << (int)Walker->AdaptiveOrder << " and is " << (!Walker->MaxOrder ? "not " : " ") << "maxed." << endl;
     }
     file.close();
@@ -3196,5 +3247,5 @@
   Free((void **)&OrderArray, "molecule::ParseOrderAtSiteFromFile - *OrderArray");
   Free((void **)&MaxArray, "molecule::ParseOrderAtSiteFromFile - *MaxArray");
-  
+
   *out << Verbose(1) << "End of ParseOrderAtSiteFromFile" << endl;
   return status;
@@ -3254,5 +3305,5 @@
   Walker = start;
   while (Walker->next != end) {
-    Walker = Walker->next; 
+    Walker = Walker->next;
     *out << Verbose(4) << "Atom " << Walker->Name << "/" << Walker->nr << " with " << NumberOfBondsPerAtom[Walker->nr] << " bonds: ";
     TotalDegree = 0;
@@ -3262,5 +3313,5 @@
     }
     *out << " -- TotalDegree: " << TotalDegree << endl;
-  }      
+  }
   *out << Verbose(1) << "End of Creating ListOfBondsPerAtom." << endl << endl;
 };
@@ -3268,5 +3319,5 @@
 /** Adds atoms up to \a BondCount distance from \a *Root and notes them down in \a **AddedAtomList.
  * Gray vertices are always enqueued in an StackClass<atom *> FIFO queue, the rest is usual BFS with adding vertices found was
- * white and putting into queue. 
+ * white and putting into queue.
  * \param *out output stream for debugging
  * \param *Mol Molecule class to add atoms to
@@ -3277,5 +3328,5 @@
  * \param BondOrder maximum distance for vertices to add
  * \param IsAngstroem lengths are in angstroem or bohrradii
- */  
+ */
 void molecule::BreadthFirstSearchAdd(ofstream *out, molecule *Mol, atom **&AddedAtomList, bond **&AddedBondList, atom *Root, bond *Bond, int BondOrder, bool IsAngstroem)
 {
@@ -3303,5 +3354,5 @@
   }
   ShortestPathList[Root->nr] = 0;
-  
+
   // and go on ... Queue always contains all lightgray vertices
   while (!AtomStack->IsEmpty()) {
@@ -3311,5 +3362,5 @@
     // followed by n+1 till top of stack.
     Walker = AtomStack->PopFirst(); // pop oldest added
-    *out << Verbose(1) << "Current Walker is: " << Walker->Name << ", and has " << NumberOfBondsPerAtom[Walker->nr] << " bonds." << endl; 
+    *out << Verbose(1) << "Current Walker is: " << Walker->Name << ", and has " << NumberOfBondsPerAtom[Walker->nr] << " bonds." << endl;
     for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {
       Binder = ListOfBondsPerAtom[Walker->nr][i];
@@ -3318,9 +3369,9 @@
         *out << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *Binder << "." << endl;
         if (ColorList[OtherAtom->nr] == white) {
-          if (Binder != Bond) // let other atom white if it's via Root bond. In case it's cyclic it has to be reached again (yet Root is from OtherAtom already black, thus no problem) 
+          if (Binder != Bond) // let other atom white if it's via Root bond. In case it's cyclic it has to be reached again (yet Root is from OtherAtom already black, thus no problem)
             ColorList[OtherAtom->nr] = lightgray;
           PredecessorList[OtherAtom->nr] = Walker;  // Walker is the predecessor
           ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
-          *out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " " << ((ColorList[OtherAtom->nr] == white) ? "white" : "lightgray") << ", its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl; 
+          *out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " " << ((ColorList[OtherAtom->nr] == white) ? "white" : "lightgray") << ", its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
           if ((((ShortestPathList[OtherAtom->nr] < BondOrder) && (Binder != Bond))) ) { // Check for maximum distance
             *out << Verbose(3);
@@ -3370,5 +3421,5 @@
           // This has to be a cyclic bond, check whether it's present ...
           if (AddedBondList[Binder->nr] == NULL) {
-            if ((Binder != Bond) && (Binder->Cyclic) && (((ShortestPathList[Walker->nr]+1) < BondOrder))) { 
+            if ((Binder != Bond) && (Binder->Cyclic) && (((ShortestPathList[Walker->nr]+1) < BondOrder))) {
               AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
               AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
@@ -3385,5 +3436,5 @@
     }
     ColorList[Walker->nr] = black;
-    *out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl; 
+    *out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
   }
   Free((void **)&PredecessorList, "molecule::BreadthFirstSearchAdd: **PredecessorList");
@@ -3409,10 +3460,10 @@
 
   *out << Verbose(2) << "Begin of BuildInducedSubgraph." << endl;
-  
+
   // reset parent list
   *out << Verbose(3) << "Resetting ParentList." << endl;
   for (int i=Father->AtomCount;i--;)
     ParentList[i] = NULL;
-  
+
   // fill parent list with sons
   *out << Verbose(3) << "Filling Parent List." << endl;
@@ -3455,5 +3506,5 @@
  * \param *&Leaf KeySet to look through
  * \param *&ShortestPathList list of the shortest path to decide which atom to suggest as removal candidate in the end
- * \param index of the atom suggested for removal 
+ * \param index of the atom suggested for removal
  */
 int molecule::LookForRemovalCandidate(ofstream *&out, KeySet *&Leaf, int *&ShortestPathList)
@@ -3461,5 +3512,5 @@
   atom *Runner = NULL;
   int SP, Removal;
-  
+
   *out << Verbose(2) << "Looking for removal candidate." << endl;
   SP = -1; //0;  // not -1, so that Root is never removed
@@ -3479,7 +3530,7 @@
 /** Stores a fragment from \a KeySet into \a molecule.
  * First creates the minimal set of atoms from the KeySet, then creates the bond structure from the complete
- * molecule and adds missing hydrogen where bonds were cut. 
+ * molecule and adds missing hydrogen where bonds were cut.
  * \param *out output stream for debugging messages
- * \param &Leaflet pointer to KeySet structure 
+ * \param &Leaflet pointer to KeySet structure
  * \param IsAngstroem whether we have Ansgtroem or bohrradius
  * \return pointer to constructed molecule
@@ -3492,10 +3543,10 @@
   bool LonelyFlag = false;
   int size;
-  
+
 //  *out << Verbose(1) << "Begin of StoreFragmentFromKeyset." << endl;
-  
+
   Leaf->BondDistance = BondDistance;
   for(int i=NDIM*2;i--;)
-    Leaf->cell_size[i] = cell_size[i]; 
+    Leaf->cell_size[i] = cell_size[i];
 
   // initialise SonList (indicates when we need to replace a bond with hydrogen instead)
@@ -3510,5 +3561,5 @@
     size++;
   }
-  
+
   // create the bonds between all: Make it an induced subgraph and add hydrogen
 //  *out << Verbose(2) << "Creating bonds from father graph (i.e. induced subgraph creation)." << endl;
@@ -3520,21 +3571,21 @@
     if (SonList[FatherOfRunner->nr] != NULL)  {  // check if this, our father, is present in list
       // create all bonds
-      for (int i=0;i<NumberOfBondsPerAtom[FatherOfRunner->nr];i++) { // go through every bond of father 
+      for (int i=0;i<NumberOfBondsPerAtom[FatherOfRunner->nr];i++) { // go through every bond of father
         OtherFather = ListOfBondsPerAtom[FatherOfRunner->nr][i]->GetOtherAtom(FatherOfRunner);
 //        *out << Verbose(2) << "Father " << *FatherOfRunner << " of son " << *SonList[FatherOfRunner->nr] << " is bound to " << *OtherFather;
         if (SonList[OtherFather->nr] != NULL) {
-//          *out << ", whose son is " << *SonList[OtherFather->nr] << "." << endl; 
+//          *out << ", whose son is " << *SonList[OtherFather->nr] << "." << endl;
           if (OtherFather->nr > FatherOfRunner->nr) { // add bond (nr check is for adding only one of both variants: ab, ba)
 //            *out << Verbose(3) << "Adding Bond: ";
-//            *out << 
+//            *out <<
             Leaf->AddBond(Runner, SonList[OtherFather->nr], ListOfBondsPerAtom[FatherOfRunner->nr][i]->BondDegree);
 //            *out << "." << endl;
             //NumBonds[Runner->nr]++;
-          } else { 
+          } else {
 //            *out << Verbose(3) << "Not adding bond, labels in wrong order." << endl;
           }
           LonelyFlag = false;
         } else {
-//          *out << ", who has no son in this fragment molecule." << endl; 
+//          *out << ", who has no son in this fragment molecule." << endl;
 #ifdef ADDHYDROGEN
           //*out << Verbose(3) << "Adding Hydrogen to " << Runner->Name << " and a bond in between." << endl;
@@ -3554,5 +3605,5 @@
     while ((Runner->next != Leaf->end) && (Runner->next->type->Z == 1)) // skip added hydrogen
       Runner = Runner->next;
-#endif       
+#endif
   }
   Leaf->CreateListOfBondsPerAtom(out);
@@ -3587,5 +3638,5 @@
   StackClass<atom *> *TouchedStack = new StackClass<atom *>((int)pow(4,Order)+2); // number of atoms reached from one with maximal 4 bonds plus Root itself
   StackClass<atom *> *SnakeStack = new StackClass<atom *>(Order+1); // equal to Order is not possible, as then the StackClass<atom *> cannot discern between full and empty stack!
-  MoleculeLeafClass *Leaflet = NULL, *TempLeaf = NULL; 
+  MoleculeLeafClass *Leaflet = NULL, *TempLeaf = NULL;
   MoleculeListClass *FragmentList = NULL;
   atom *Walker = NULL, *OtherAtom = NULL, *Root = NULL, *Removal = NULL;
@@ -3637,5 +3688,5 @@
 		// clear snake stack
 	  SnakeStack->ClearStack();
-    //SnakeStack->TestImplementation(out, start->next);    
+    //SnakeStack->TestImplementation(out, start->next);
 
     ///// INNER LOOP ////////////
@@ -3658,5 +3709,5 @@
         }
         if (ShortestPathList[Walker->nr] == -1) {
-          ShortestPathList[Walker->nr] = ShortestPathList[PredecessorList[Walker->nr]->nr]+1; 
+          ShortestPathList[Walker->nr] = ShortestPathList[PredecessorList[Walker->nr]->nr]+1;
           TouchedStack->Push(Walker); // mark every atom for lists cleanup later, whose shortest path has been changed
         }
@@ -3696,10 +3747,10 @@
     				OtherAtom = Binder->GetOtherAtom(Walker);
             if ((Labels[OtherAtom->nr] != -1) && (Labels[OtherAtom->nr] < Labels[Root->nr])) { // we don't step up to labels bigger than us
-              *out << "Label " << Labels[OtherAtom->nr] << " is smaller than Root's " << Labels[Root->nr] << "." << endl; 
+              *out << "Label " << Labels[OtherAtom->nr] << " is smaller than Root's " << Labels[Root->nr] << "." << endl;
               //ColorVertexList[OtherAtom->nr] = lightgray;    // mark as explored
             } else { // otherwise check its colour and element
       				if (
 #ifdef ADDHYDROGEN
-              (OtherAtom->type->Z != 1) && 
+              (OtherAtom->type->Z != 1) &&
 #endif
                     (ColorEdgeList[Binder->nr] == white)) {  // skip hydrogen, look for unexplored vertices
@@ -3711,11 +3762,11 @@
                 //} else {
                 //  *out << Verbose(3) << "Predecessor of " << OtherAtom->Name << " is " << PredecessorList[OtherAtom->nr]->Name << "." << endl;
-                //} 
+                //}
                 Walker = OtherAtom;
                 break;
               } else {
-                if (OtherAtom->type->Z == 1) 
+                if (OtherAtom->type->Z == 1)
                   *out << "Links to a hydrogen atom." << endl;
-                else                 
+                else
                   *out << "Bond has not white but " << GetColor(ColorEdgeList[Binder->nr]) << " color." << endl;
               }
@@ -3727,5 +3778,5 @@
           *out << Verbose(3) << "We have gone too far, stepping back to " << Walker->Name << "." << endl;
         }
-  			if (Walker != OtherAtom) {	// if no white neighbours anymore, color it black 
+  			if (Walker != OtherAtom) {	// if no white neighbours anymore, color it black
           *out << Verbose(2) << "Coloring " << Walker->Name << " black." << endl;
   				ColorVertexList[Walker->nr] = black;
@@ -3734,5 +3785,5 @@
       }
   	} while ((Walker != Root) || (ColorVertexList[Root->nr] != black));
-    *out << Verbose(2) << "Inner Looping is finished." << endl;    
+    *out << Verbose(2) << "Inner Looping is finished." << endl;
 
     // if we reset all AtomCount atoms, we have again technically O(N^2) ...
@@ -3750,8 +3801,8 @@
     }
   }
-  *out << Verbose(1) << "Outer Looping over all vertices is done." << endl; 
+  *out << Verbose(1) << "Outer Looping over all vertices is done." << endl;
 
   // copy together
-  *out << Verbose(1) << "Copying all fragments into MoleculeList structure." << endl; 
+  *out << Verbose(1) << "Copying all fragments into MoleculeList structure." << endl;
   FragmentList = new MoleculeListClass(FragmentCounter, AtomCount);
   RunningIndex = 0;
@@ -3824,18 +3875,18 @@
 
   NumCombinations = 1 << SetDimension;
-  
+
   // Hier muessen von 1 bis NumberOfBondsPerAtom[Walker->nr] alle Kombinationen
   // von Endstuecken (aus den Bonds) hinzugefï¿œï¿œgt werden und fï¿œï¿œr verbleibende ANOVAOrder
   // rekursiv GraphCrawler in der nï¿œï¿œchsten Ebene aufgerufen werden
-  
+
   *out << Verbose(1+verbosity) << "Begin of SPFragmentGenerator." << endl;
   *out << Verbose(1+verbosity) << "We are " << RootDistance << " away from Root, which is " << *FragmentSearch->Root << ", SubOrder is " << SubOrder << ", SetDimension is " << SetDimension << " and this means " <<  NumCombinations-1 << " combination(s)." << endl;
 
-  // initialised touched list (stores added atoms on this level) 
+  // initialised touched list (stores added atoms on this level)
   *out << Verbose(1+verbosity) << "Clearing touched list." << endl;
   for (TouchedIndex=SubOrder+1;TouchedIndex--;)  // empty touched list
     TouchedList[TouchedIndex] = -1;
   TouchedIndex = 0;
-  
+
   // create every possible combination of the endpieces
   *out << Verbose(1+verbosity) << "Going through all combinations of the power set." << endl;
@@ -3845,5 +3896,5 @@
     for (int j=SetDimension;j--;)
       bits += (i & (1 << j)) >> j;
-      
+
     *out << Verbose(1+verbosity) << "Current set is " << Binary(i | (1 << SetDimension)) << ", number of bits is " << bits << "." << endl;
     if (bits <= SubOrder) { // if not greater than additional atoms allowed on stack, continue
@@ -3853,8 +3904,8 @@
         bit = ((i & (1 << j)) != 0);  // mask the bit for the j-th bond
         if (bit) {  // if bit is set, we add this bond partner
-        	OtherWalker = BondsSet[j]->rightatom;	// rightatom is always the one more distant, i.e. the one to add 
+        	OtherWalker = BondsSet[j]->rightatom;	// rightatom is always the one more distant, i.e. the one to add
           //*out << Verbose(1+verbosity) << "Current Bond is " << ListOfBondsPerAtom[Walker->nr][i] << ", checking on " << *OtherWalker << "." << endl;
           *out << Verbose(2+verbosity) << "Adding " << *OtherWalker << " with nr " << OtherWalker->nr << "." << endl;
-          TestKeySetInsert = FragmentSearch->FragmentSet->insert(OtherWalker->nr); 
+          TestKeySetInsert = FragmentSearch->FragmentSet->insert(OtherWalker->nr);
           if (TestKeySetInsert.second) {
             TouchedList[TouchedIndex++] = OtherWalker->nr;  // note as added
@@ -3869,6 +3920,6 @@
         }
       }
-      
-      SpaceLeft = SubOrder - Added ;// SubOrder - bits; // due to item's maybe being already present, this does not work anymore 
+
+      SpaceLeft = SubOrder - Added ;// SubOrder - bits; // due to item's maybe being already present, this does not work anymore
       if (SpaceLeft > 0) {
         *out << Verbose(1+verbosity) << "There's still some space left on stack: " << SpaceLeft << "." << endl;
